<template>
    <div v-for="sportBet in PaidSportBets" :key="sportBet.RefNo" class="m-4 border-2 border-color rounded-lg">
        <div
            v-if="sportBet"
        >
            <div class="px-4 py-2 border-b-2 border-color">
              TXN no. <span class="font-bold">{{ sportBet.RefNo }}</span>
            </div>
            <div class="border-b-2 border-color" v-if="allSportBets.length === 1">
              <p v-if="!isFromPreviousQrPage && checkQrUrlApp && !isFromShopOwner" class="mx-4 mt-4 text-xs">
                {{ sportQrHelper.getLang('Please keep this website page or', language) }}
                <span class="fc-hint">
                   {{ sportQrHelper.getLang('Take a Screenshot', language) }}
                </span> 
                 {{ sportQrHelper.getLang('of the page for verification of the winning', language) }}
              </p>
              <p v-else-if="!isFromShopOwner" class="mx-4 mt-4 b2 text-xs">
                {{ $t('Please keep this website page or') }}
                <span class="fc-hint">
                   {{ $t('Take a Screenshot') }}
                </span> 
                 {{ $t('of the page for verification of the winning') }}
              </p>
              <div class="flex justify-center items-center px-4 py-2" v-if="!isFromShopOwner">
                <svg xmlns="http://www.w3.org/2000/svg" width="120" height="120" viewBox="0 0 122 122" fill="none">
                  <path d="M106.128 1H121V15.8925M106.128 121H121V106.108M15.8724 1H1V15.8925M15.8724 121H1V106.108" stroke="#31C46E" stroke-linecap="round" stroke-linejoin="round"/>
                </svg>
                <qrcode-vue
                  id="qrCode"
                  :value="link"
                  :size="parseInt('110')"
                  class="p-2 bg-white absolute"
                >
                </qrcode-vue>
              </div>
            </div>
            <div class="px-4 py-2 border-b-2 border-color">
              <div v-if="checkQrUrlApp" class="flex justify-between items-baseline self-stretch mb-2">
                <p class="font-bold" :class="sportBetsHelper.convertOperationStatusTextColor(sportBet.OperationStatus)">
                  {{ sportQrHelper.getLang(sportBetsHelper.convertOperationStatusTextDisplay(sportBet.OperationStatus, operatorId).toLowerCase(), language) }}
                </p>
                <p class="text-2xl font-bold uppercase" :class="sportBetsHelper.convertBetStausTextColor(sportBet.Status)">{{ sportQrHelper.getLang(sportBet.Status.toLowerCase(), language)}}</p>
              </div>
              <div v-else class="flex justify-between items-baseline self-stretch mb-2">
                <p class="font-bold" :class="sportBetsHelper.convertOperationStatusTextColor(sportBet.OperationStatus)">
                  {{ $t(sportBetsHelper.convertOperationStatusTextDisplay(sportBet.OperationStatus, operatorId).toLowerCase()) }}
                </p>
                <p class="text-2xl font-bold uppercase" :class="sportBetsHelper.convertBetStausTextColor(sportBet.Status)">{{ $t(sportBet.Status.toLowerCase())}}</p>
              </div>
              <div v-if="checkQrUrlApp" class="text-xs">{{ sportQrHelper.getLang('bet time', language) }}: {{ sportBet.OrderTime }} (GMT-4)</div>
              <div v-else class="text-xs">{{ $t('bet_time') }}: {{ sportBet.OrderTime }} (GMT-4)</div>
            </div>
            <template
                v-for="(betDetail, index) in sportBet.BetDetails"
                :key="index"
              >
              <div class="px-4 py-2 border-b-2 border-color">
                <div class="flex gap-1 items-center">
                  <div class="text-xs">{{ betDetail.SportType }} - {{ betDetail.MarketType }}</div>
                  <div v-if="sportBet.IsLiveBet" class="flex items-center gap-1">
                      <svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg">
                          <path fill-rule="evenodd" clip-rule="evenodd" d="M2.66669 4.3335H13.3334C13.8856 4.3335 14.3334 4.78121 14.3334 5.3335V10.6668C14.3334 11.2191 13.8856 11.6668 13.3334 11.6668H2.66669C2.1144 11.6668 1.66669 11.2191 1.66669 10.6668V5.3335C1.66669 4.78121 2.1144 4.3335 2.66669 4.3335ZM0.666687 5.3335C0.666687 4.22893 1.56212 3.3335 2.66669 3.3335H13.3334C14.4379 3.3335 15.3334 4.22893 15.3334 5.3335V10.6668C15.3334 11.7714 14.4379 12.6668 13.3334 12.6668H2.66669C1.56212 12.6668 0.666687 11.7714 0.666687 10.6668V5.3335ZM3.22588 6.16683L2.66669 9.8335H4.94294L5.06794 9.03141H3.70613L4.14033 6.16683H3.22588ZM6.22704 9.8335L6.78624 6.16683H5.87179L5.31259 9.8335H6.22704ZM8.14064 6.16683L8.43669 8.75212H8.463L9.5485 6.16683H10.5814L8.91036 9.8335H7.66039L7.10777 6.16683H8.14064ZM10.9058 6.16683L10.3466 9.8335H12.7676L12.8926 9.03141H11.386L11.4781 8.4012H12.8663L12.9913 7.59912H11.6031L11.6952 6.96891H13.2084L13.3334 6.16683H10.9058Z" fill="#FF265C"/>
                      </svg>
                      <p class="text-xs">@ {{ betDetail.LiveScore }}</p>
                  </div>
                </div>
                <div class="text-xs">
                  {{ betDetail.BetOption }} {{ betDetail.HandicapPoint }} @ {{ betDetail.SubBetOdds }}
                </div>
              </div>
              <div class="px-4 py-2 border-b-2 border-color text-xs">
                <div>{{ betDetail.League }}</div>
                <div>{{ betDetail.Match }}</div>
                <div>@{{ betDetail.kickOffTimeForDisplay }} (GMT -4)</div>
              </div>
            </template>
            <div class="px-4 py-2">
              <div class="flex justify-between text-xs">
                <div v-if="checkQrUrlApp">{{ sportQrHelper.getLang('stake', language) }}</div>
                <div v-else>{{ $t('stake') }}</div>
                <div>{{ sportBet.StakeForDisplay }} {{ sportBet.Currency }}</div>
              </div>
              <div
                v-if="showWinLose(sportBet.Status)"
                class="flex justify-between"
              >
                <div v-if="checkQrUrlApp">{{ sportQrHelper.getLang('winlose', language) }}</div>
                <div v-else>{{ $t('winlose') }}</div>
                <div>
                  <span :style="`color:${sportBet.Winlose < 0 ? 'red' : ''}`">{{
                    sportBet.WinLoseForDisplay
                  }}</span>
                  {{ sportBet.Currency }}
                </div>
              </div>
              <div
                v-if="showPayout(sportBet.Status) && operatorId === 0"
                class="flex justify-between"
              >
                <div v-if="checkQrUrlApp">{{ sportQrHelper.getLang('payout', language) }}</div>
                <div v-else>{{ $t('payout') }}</div>
                <div>
                  <span :style="`color:${sportBet.Payout < 0 ? 'red' : ''}`" class="text-base mr-1">{{
                    sportBet.PayoutForDisplay
                  }}</span>
                  <span>
                    {{ sportBet.Currency }}
                  </span>
                </div>
              </div>
            </div>
            <div class="px-4 py-2 flex justify-between border-t-2 border-color" 
              v-if="showPayoutButton(sportBet.OperationStatus, sportBet.Status) 
              || showRefundButton(sportBet.OperationStatus, sportBet.Status)">
              <div>
                <span v-if="checkQrUrlApp">{{ sportQrHelper.getLang('payout', language) }}</span>
                <span v-else>{{ $t('payout') }}</span>
                <span class="text-2xl font-bold ml-1">{{ sportBet.PayoutForDisplay }} </span>
                <span class="text-base ml-1">{{ sportBet.Currency }}</span>
              </div>
              <div>
                <el-button
                  v-if="showPayoutButton(sportBet.OperationStatus, sportBet.Status)"
                  class="el-button--primary sport-qr-btn"
                  @click="onRedeemTicket(sportBet.RefNo)"
                  :loading="isRedeemedTicketLoading"
                >
                  <span v-if="checkQrUrlApp">{{ sportQrHelper.getLang('payout', language) }}</span>
                  <span v-else>{{ $t('payout') }}</span>
                </el-button>
                <el-button
                  v-if="showRefundButton(sportBet.OperationStatus, sportBet.Status)"
                  class="el-button--primary sport-qr-btn"
                  @click="onRedeemTicket(sportBet.RefNo)"
                  :loading="isRedeemedTicketLoading"
                >
                  <span v-if="checkQrUrlApp">{{ sportQrHelper.getLang('refund', language) }}</span>
                  <span v-else>{{ $t('refund') }}</span>
                </el-button>
              </div>
            </div>
            <div class="px-4 py-2 flex justify-between items-baseline self-stretch border-t-2 border-color" v-if="operatorId !== 0 && showWinLose(sportBet.Status) && !showPayoutButton(sportBet.OperationStatus, sportBet.Status)">
              <div v-if="checkQrUrlApp">{{ sportQrHelper.getLang('payout', language) }}</div>
              <div v-else>{{ $t('payout') }}</div>
              <div>
                <span class="text-2xl font-bold ml-1">{{ sportBet.PayoutForDisplay }} </span>
                <span class="text-base ml-1">{{ sportBet.Currency }}</span>
              </div>
            </div>
            <div class="px-4 py-2 flex justify-between items-baseline self-stretch border-t-2 border-color" v-if="operatorId !== 0 && sportBet.OperationStatus.toLocaleLowerCase() === EnumOperationStatus.refund && sportBet.Status.toLocaleLowerCase() === EnumSportBetStatus.void && !showRefundButton(sportBet.OperationStatus, sportBet.Status)" >
              <div v-if="checkQrUrlApp">{{ sportQrHelper.getLang('refunded', language) }}</div>
              <div v-else>{{ $t('refunded') }}</div>
              <div>
                <span class="text-2xl font-bold ml-1">{{ sportBet.PayoutForDisplay }} </span>
                <span class="text-base ml-1">{{ sportBet.Currency }}</span>
              </div>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">
import { SportBet } from '~~/models/sportbet/sportbet';
import sportBetsHelper from '@/utils/sportBetsHelper';
// import sportQrHelper from '@/utils/sportQrHelper';
import EnumSportBetStatus from '~~/models/enums/enumSportBetStatus';
import EnumOperationStatus from '~~/models/enums/enumOperationStatus';
import numberFormatHelper from "@/utils/formatHelpers/numberFormatHelper";
import QrcodeVue from "qrcode.vue";
import hasHandicapPoint from "~~/models/enums/enumBetType";

const props = defineProps({
    allSportBets: {
        type: Array as PropType<SportBet[]>,
        required: true
    },
    PaidSportBets: {
        type: Array as PropType<SportBet[]>,
        required: true
    },
    operatorId: {
        type: null,
        default: 0,
    },
    operatorToken: {
        type: null,
        default: '',
    },
    isFromPreviousQrPage: {
        type: Boolean,
        default: false,
    },
    totalStakePaidForDisplay: {
        type: String,
        default: '',
  },
    onRedeemTicket: {
        type: Function,
        required: true,
  },
  isRedeemedTicketLoading: {
        type: Boolean,
        default: false,
  },
  link: {
        type: String,
        default: '',
  },
});

const currency = computed(() => props.PaidSportBets[0].Currency) ?? '';
const language = useRoute().query.lang ?? 'en';
const winLose: EnumSportBetStatus[] = [
    EnumSportBetStatus.won,
    EnumSportBetStatus.halfwon,
    EnumSportBetStatus.halflose,
    EnumSportBetStatus.lost,
    EnumSportBetStatus.draw,
];
const payout: EnumSportBetStatus[] = [
    EnumSportBetStatus.running,
    EnumSportBetStatus.waiting,
    EnumSportBetStatus.void,
]
const showWinLose = (betStatus: string) => {
    return winLose.includes(betStatus.toLowerCase() as EnumSportBetStatus);
}
const showPayout = (betStatus: string) => {
    return !payout.includes(betStatus.toLowerCase() as EnumSportBetStatus);
}
const showPayoutButton = (operationStatus: string, betStatus: string) => {
    return !props.isFromPreviousQrPage && props.operatorId && operationStatus.toLowerCase() === EnumOperationStatus.paid
        && [EnumSportBetStatus.won, EnumSportBetStatus.halfwon, EnumSportBetStatus.draw, EnumSportBetStatus.halflose].includes(betStatus.toLowerCase() as EnumSportBetStatus);
}
const showRefundButton = (operationStatus: string, betStatus: string) => {
    return !props.isFromPreviousQrPage && props.operatorId  && operationStatus.toLowerCase() === EnumOperationStatus.paid
        && betStatus.toLowerCase() === EnumSportBetStatus.void;
}
const qrUrl = computed(() => {
  return window.location.search;
});
const checkQrUrlApp = qrUrl.value.includes('lang=');
const isFromShopOwner = useRoute().query.isFromShopOwner;
</script>

<style lang="scss">
.el-button {
  &.el-button--primary {
    &.sport-qr-btn {
      border-radius: 30px;
    }
  }
}
</style>


